#ifndef lint
static char *rcsid = "$Header: /usr/src/local/awl/RCS/Awl.c,v 2.1 90/04/19 20:04:01 jkh Exp $";
#endif

/*
 *
 *                   Copyright 1989, 1990
 *                    Jordan K. Hubbard
 *
 *		  PCS Computer Systeme, GmbH.
 *	             Munich, West Germany
 *
 *
 * This file is part of AWL.
 *
 * AWL is free software; you can redistribute it and/or modify
 * it under the terms of the GNU General Public License as published by
 * the Free Software Foundation; either version 1, or (at your option)
 * any later version.
 *
 * AWL is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 *
 * You should have received a copy of the GNU General Public License
 * along with AWL; see the file COPYING.  If not, write to
 * the Free Software Foundation, 675 Mass Ave, Cambridge, MA 02139, USA.
 *
 *
 */

/*
 * AWL itself is spread over many files, however all internal data and
 * awl public functions are declared here.
 *
 * $Log:	Awl.c,v $
 * Revision 2.1  90/04/19  20:04:01  jkh
 * Alpha checkin.
 * 
 * Revision 2.0  90/03/26  01:42:04  jkh
 * pre-beta check-in
 * 
 */

/* #include <X11/AwlP.h> */
#include "AwlP.h"
#include "y.tab.h"

#define offset(name)    XtOffset(AwlWidget, awl.res.name)

Local XtResource awlResources[] = {
     {XgNcppArg,  XgCCppArg,		XtRString,	sizeof(String),
	   offset(cpp_args),		XtRString,	" "},
     {XgNcppCommand,	XgCCppCommand,	XtRString,	sizeof(String),
	   offset(cpp_command),		XtRString,	XgDefaultCppCommand},
     {XgNdebug,		XgCDebug,	XtRBoolean,	sizeof(Boolean),
           offset(debug),		XtRImmediate,	(caddr_t)False},
     {XgNexternList,	XgCExternList,	XtRPointer,	sizeof(AwlExternList),
	   offset(externlist),		XtRPointer,	NULL},
     {XgNfile,		XgCFile,	XtRString,	sizeof(String),
	   offset(file),		XtRString,	NULL},
     {XgNline,		XgCLine,	XtRBoolean,	sizeof(Boolean),
	   offset(lineinfo),		XtRImmediate,	(caddr_t)False},
     {XgNmainArgv,	XgCMainArgv,	XtRStringArray,	sizeof(String *),
	   offset(argv),		XtRImmediate,	NULL},
     {XgNnoWarn,	XgCNoWarn,	XtRBoolean,	sizeof(Boolean),
	   offset(nowarn),		XtRImmediate,	(caddr_t)False},
     {XgNshow,		XgCShow,	XtRBoolean,	sizeof(Boolean),
	   offset(showasm),		XtRImmediate,	(caddr_t)False},
     {XgNstart,		XgCStart,	XtRString,	sizeof(String),
	   offset(startfunc),		XtRString,	"main"},
     {XgNtrace,		XgCTrace,	XtRBoolean,	sizeof(Boolean),
	   offset(trace),		XtRImmediate,	(caddr_t)False},
     {XgNversion,	XgCVersion,	XtRBoolean,	sizeof(Boolean),
	   offset(version),		XtRImmediate,	(caddr_t)False},
};

#undef offset

Local void Initialize(), Destroy(), clean_house();
Local Boolean SetValues();

Export AwlClassRec awlClassRec = {
  { /* core fields */
    /* superclass		*/	(WidgetClass) &topLevelShellClassRec,
    /* class_name		*/	"Awl",
    /* widget_size		*/	sizeof(AwlRec),
    /* class_initialize		*/	NULL,
    /* class_part_initialize	*/	NULL,
    /* class_inited		*/	False,
    /* initialize		*/	Initialize,
    /* initialize_hook		*/	NULL,
    /* realize			*/	XtInheritRealize,
    /* actions			*/	NULL,
    /* num_actions		*/	0,
    /* resources		*/	awlResources,
    /* num_resources		*/	XtNumber(awlResources),
    /* xrm_class		*/	NULLQUARK,
    /* compress_motion		*/	True,
    /* compress_exposure	*/	True,
    /* compress_enterleave	*/	True,
    /* visible_interest		*/	False,
    /* destroy			*/	Destroy,
    /* resize			*/	XtInheritResize,
    /* expose			*/	XtInheritExpose,
    /* set_values		*/	SetValues,
    /* set_values_hook		*/	NULL,
    /* set_values_almost	*/	XtInheritSetValuesAlmost,
    /* get_values_hook		*/	NULL,
    /* accept_focus		*/	XtInheritAcceptFocus,
    /* version			*/	XtVersion,
    /* callback_private		*/	NULL,
    /* tm_table			*/	NULL,
    /* query_geometry		*/	XtInheritQueryGeometry,
    /* display_accelerator	*/	XtInheritDisplayAccelerator,
    /* extension		*/	NULL
  },
  { /* composite fields */
    /* geometry_manager */	XtInheritGeometryManager,
    /* change_managed	*/	XtInheritChangeManaged,
    /* insert_child	*/	XtInheritInsertChild,
    /* delete_child	*/	XtInheritDeleteChild,
    /* extension	*/	NULL
  },
  { /* shell fields	*/
    /* extension	*/	NULL
  },
  { /* wmshell fields	*/
    /* extension	*/	NULL
  },
  { /* vendorshell fields */
    /* extension	*/	NULL
  },
  { /* toplevelshell fields */
    /* extension	*/	NULL
  },
  { /* awl fields	*/
    /* empty		*/	0
  }
};

Export WidgetClass awlWidgetClass = (WidgetClass)&awlClassRec;

/* VARARGS */
Export caddr_t awl_call(va_alist)
va_dcl
{
     va_list ap;
     AwlWidget aw;
     String func;
     Value val;
     Symbol f;
     char *lpar, *rpar, *tmp;
     int type = ANY, uns = FALSE;

     va_start(ap);
     aw = va_arg(ap, AwlWidget);
     tmp = va_arg(ap, String);
     func = tmp = XtNewString(tmp);

     debug(aw, "awl_call: Invoking '%s' as start func", tmp);
     do_link(aw);
     lpar = index(func, '(');
     rpar = rindex(func, ')');
     if (lpar && rpar) {
	  int state = 0;

	  *lpar = '\0';
	  while (++lpar < rpar) {
	       switch (*lpar) {
	       case '%':
		    state = 1;
		    break;

	       case 'a':
		    if (state) {
			 debug(aw, "awl_call: pushing a generic parameter");
			 value_set(val, DATA, ANY, any, va_arg(ap, Generic));
			 push(aw, val);
			 state = 0;
		    }
		    else
			 exec_warn(aw, "awl_call: Bad '%CHAR' in format");
		    break;

	       case 'c':
		    if (state) {
			 debug(aw, "awl_call: pushing a char parameter");
			 value_set(val, DATA, CHAR, char, va_arg(ap, char));
			 push(aw, val);
			 state = 0;
		    }
		    else
			 exec_warn(aw, "awl_call: Bad '%CHAR' in format");
		    break;

	       case 'h':
		    state = 2;
		    break;

	       case 'l':
		    state = 4;
		    break;

	       case 'd': case 'i': case 'o': case 'O':
	       case 'u': case 'x': case 'X':
		    if (state) {
			 int tmp;

			 if (*lpar == 'u')
			      uns = TRUE;
			 else
			      uns = FALSE;
			 if (state == 1) {
			      if (!uns)
				   tmp = va_arg(ap, int);
			      else
				   tmp = va_arg(ap, unsigned int);
			 }
			 else if (state == 2) {
			      if (!uns)
				   tmp = (int)va_arg(ap, short);
			      else
				   tmp = (int)va_arg(ap, unsigned short);
			 }
			 else {
			      if (!uns)
				   tmp = (int)va_arg(ap, long);
			      else
				   tmp = (int)va_arg(ap, unsigned long);
			 }
			 debug(aw, "awl_call: pushing an int/%d parameter",
			       state);
			 value_set(val, DATA, INT, int, tmp);
			 push(aw, val);
			 state = 0;
		    }
		    else
			 exec_warn(aw, "awl_call: Bad '%INT' in format");
		    break;

	       case 'e': case 'E': case 'f': case 'g': case 'G':
		    if (state) {
			 debug(aw, "awl_call: pushing a float parameter");
			 value_set(val, DATA, FLOAT, float, va_arg(ap, float));
			 push(aw, val);
			 state = 0;
		    }
		    else
			 exec_warn(aw, "awl_call: Bad '%FLOAT' in format");
		    break;

	       case 's':
		    if (state) {
			 debug(aw, "awl_call: pushing a string parameter");
			 value_set(val, STATIC, STRING, aobj,
				   new_aobj(va_arg(ap, String)));
			 push(aw, val);
			 state = 0;
		    }
		    else
			 exec_warn(aw, "awl_call: Bad '%STRING' in format");
		    break;

	       case 'L':
		    if (state) {
			 debug(aw, "awl_call: pushing a list parameter");
			 value_set(val, STATIC, LIST, aobj,
				   new_aobj(va_arg(ap, String *)));
			 push(aw, val);
			 state = 0;
		    }
		    else
			 exec_warn(aw, "awl_call: Bad '%LIST' in format");
		    break;

	       case '0': case '1': case '2': case '3': case '4':
	       case '5': case '6': case '7': case '8': case '9':
		    /* simply ignore numbers unless they're bogus */
		    if (!state)
			 exec_warn(aw, "awl_call: Bad number in format");
		    break;

		    /* same for decimal points */
	       case '.':
		    if (!state)
			 exec_warn(aw,
				   "awl_call: Bogus decimal point in format");
		    break;

	       case ',':
	       case ' ':
		    break;

	       default:
		    exec_warn(aw, "awl_call: Bad char '%c' in format", *lpar);
		    break;
	       }
	  }
     }
     /* skip any leading spaces */
     func = skip_whitespace(func);
     if (*func == '%') {
	  switch (*(++func)) {
	  case 'c':
	       type = CHAR;
	       break;

	  case 'd': case 'i': case 'o': case 'O':
	  case 'u': case 'x': case 'X':
	       type = INT;
	       break;

	  case 'e': case 'E': case 'f': case 'g': case 'G':
	       type = FLOAT;
	       break;

	  case 's':
	       type = FLOAT;
	       break;
	  }
	  /* skip any trailing spaces */
	  func = skip_whitespace(func);
	  debug(aw, "awl_call: return value type set to %s", type_name(type));
     }
     if ((f = symbol_find(aw, func)) != NULL) {
	  if (symbol_is_function(f))
	       val = coerce(aw, Eval(f), type);
	  else
	       exec_error(aw, "startfunc '%s' is type '%s', not function!",
			  func, type_name(symbol_type(f)));
     }
     else
	  exec_error(aw, "Can't find startfunc named '%s'", func);
     va_end(ap);
     XtFree(tmp);

     switch (type) {
     case CHAR:
	  return((caddr_t)value_char(val));
     case INT:
	  return((caddr_t)value_int(val));
     case FLOAT:
	  {
	       static float ftemp;

	       ftemp = value_float(val);
	       return((caddr_t)&ftemp);
	  }
     AOBJCASE:
	  return((caddr_t)aobj_ptr(value_aobj(val)));
     default:
	  return((caddr_t)value_any(val));
     }
}

Local void Initialize(request, new)
Widget request;
Widget new;
{
     AwlWidget aw = (AwlWidget)new;
     Import int setjmp();

     /* Initialize the AWL universe */
     do_init(aw);

     /* deal with any special resources */
     if (awl_externlist(aw))
	  do_externs(aw, awl_externlist(aw));

     /* give us a place to bomb out to */
     if (setjmp(awl_bomb(aw))) {
	  clean_house(aw);
	  return;
     }
      /* if a start function exists, call it */
     if (!parseFile(aw, awl_file(aw))) {
	  if (awl_startfunc(aw)) {
	       if (!awl_mainargv(aw))
		    awl_call(aw, awl_startfunc(aw));
	       else {
		    char cmd[512];

		    strcpy(cmd, awl_startfunc(aw));
		    strcat(cmd, "(%d %L)");
		    awl_call(aw, cmd, list_len(awl_mainargv(aw)),
			     awl_mainargv(aw));
	       }
	  }
     }
}

Local void Destroy(w)
Widget w;
{
     AwlWidget aw = (AwlWidget)w;

     debug(aw, "Destroying awl widget '%x'", aw);
     clean_house(aw);
}

Local Boolean SetValues(current, request, new)
Widget current, request, new;
{
     AwlWidget cw = (AwlWidget)current;
     AwlWidget nw = (AwlWidget)new;

     if (awl_file(cw) != awl_file(nw) ||
	  strcomp(awl_file(cw), awl_file(nw)))
	  parseFile(nw, awl_file(nw));
     if (awl_externlist(cw) != awl_externlist(nw))
	  do_externs(nw, awl_externlist(nw));
     return(FALSE);
}

/*
 * Awl public functions.
 */

/*
 * Set a breakpoint.
 */
Export void awl_break_set(aw, addr, func)
AwlWidget aw;
int addr;
int (*func)();
{
     Breakpoint tmp;

     if (awl_bkpts(aw) == NULL)
	  awl_bkpts(aw) = tmp = new_bkpt();
     else {
	  tmp = new_bkpt();
	  bkpt_next(tmp) = awl_bkpts(aw);
	  awl_bkpts(aw) = tmp;
     }
     bkpt_addr(tmp) = addr;
     bkpt_func(tmp) = func;
     bkpt_enable(tmp) = TRUE;
     debug(aw, "awl_break_set: breakpoint set at %d to function %x",
	   addr, func);
}

Export void awl_break_delete(aw, addr)
AwlWidget aw;
int addr;
{
     Breakpoint tmp, tmp2;

     if ((tmp = awl_bkpts(aw)) == NULL)
	  XtWarning("awl_break_delete: No breakpoints set");
     else if (bkpt_addr(tmp) == addr) {
	  XtFree(awl_bkpts(aw));
	  awl_bkpts(aw) = NULL;
     }
     else {
	  while (tmp) {
	       if (bkpt_addr(tmp) == addr) {
		    bkpt_next(tmp2) = bkpt_next(tmp);
		    XtFree(tmp);
		    return;
	       }
	       tmp2 = tmp;
	       tmp = bkpt_next(tmp);
	  }
	  fprintf(stderr, "awl_break_delete: No breakpoint at addr %d\n",
		  addr);
     }
}

Local void set_enable_state(aw, addr, state)
AwlWidget aw;
int addr;
Boolean state;
{
     Breakpoint tmp;

     tmp = awl_bkpts(aw);
     while (tmp) {
	  if (bkpt_addr(tmp) == addr) {
	       bkpt_enable(tmp) = state;
	       return;
	  }
	  tmp = bkpt_next(tmp);
     }
     fprintf(stderr, "%s: No breakpoint at addr %d\n",
	     state ? "awl_break_enable" : "awl_break_disable", addr);
}

Export void awl_break_enable(aw, addr)
AwlWidget aw;
int addr;
{
     set_enable_state(aw, addr, TRUE);
}

Export void awl_break_disable(aw, addr)
AwlWidget aw;
int addr;
{
     set_enable_state(aw, addr, FALSE);
}

/*
 * This is sort of like a soft reset. First we buzz through the symbol
 * table and remove everything in sight, then we free up the stack and
 * data segments and reset all our pointers. Active layouts are
 * destroyed, any open files are closed and executing subprocesses
 * are delicately killed with a sledgehammer.
 */

/* This is far from finished.. It's more of a place-holder at the moment */
Local void clean_house(aw)
AwlWidget aw;
{
     awl_lastpc(aw) = awl_fp(aw) = awl_sp(aw) = awl_pc(aw) = 0;
}
  
