#ifndef _Awl_h
#define _Awl_h

/* $Header: /usr/src/local/awl/RCS/Awl.h,v 2.1 90/04/19 20:04:03 jkh Exp $ */

/*
 *
 *                     Copyright 1989
 *                    Jordan K. Hubbard
 *
 *		  PCS Computer Systeme, GmbH.
 *	             Munich, West Germany
 *
 *
 * This file is part of AWL.
 *
 * AWL is free software; you can redistribute it and/or modify
 * it under the terms of the GNU General Public License as published by
 * the Free Software Foundation; either version 1, or (at your option)
 * any later version.
 *
 * AWL is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 *
 * You should have received a copy of the GNU General Public License
 * along with AWL; see the file COPYING.  If not, write to
 * the Free Software Foundation, 675 Mass Ave, Cambridge, MA 02139, USA.
 *
 *
 */

/*
 * Resources:
 *
 * Name			Class		RepType		Default Value
 * ----			-----		-------		-------------
 * cppArg		CppArg		String		NULL
 * cppCommand		CppCommand	String		NULL
 * debug             	Debug 	  	Boolean		False
 * externList		ExternList	AwlExtList	NULL
 * file			File		String		NULL
 * line			Line		Boolean		False
 * mainArgv		MainArgv	String *	NULL
 * noWarn		NoWarn		Boolean		False
 * show			Show		Boolean		False
 * start		Start		String		"main"
 * trace		Trace		Boolean		False
 * version		Version		Boolean		False
 *
 */

/*
 * This is the public declarations file for the awl widget.
 * Documentation is in awl.texinfo.
 *
 * $Log:	Awl.h,v $
 * Revision 2.1  90/04/19  20:04:03  jkh
 * Alpha checkin.
 * 
 * Revision 2.0  90/03/26  01:42:06  jkh
 * pre-beta check-in
 *
 */


/* resource types */
#define XgNcppArg		"cppArg"
#define XgNcppCommand		"cppCommand"
#define XgNdebug		"debug"
#define XgNexternList		"externList"
#define XgNfile			"file"
#define XgNline			"line"
#define XgNmainArgv		"mainArgv"
#define XgNnoWarn		"noWarn"
#define XgNshow			"show"
#define XgNstart		"start"
#define XgNtrace		"trace"
#define XgNversion		"version"

/* class types */
#define XgCCppArg		"CppArg"
#define XgCCppCommand		"CppCommand"
#define XgCDebug		"Debug"
#define XgCExternList		"ExternList"
#define XgCFile			"File"
#define XgCLine			"Line"
#define XgCMainArgv		"MainArgv"
#define XgCNoWarn		"NoWarn"
#define XgCShow			"Show"
#define XgCStart		"Start"
#define XgCTrace		"Trace"
#define XgCVersion		"Version"

/*
 * How to invoke cpp on your system with line control information. If your
 * cpp doesn't generate such information, error messages will be less
 * meaningful.
 */
#define XgDefaultCppCommand	"/lib/cpp"

/* declare specific AwlWidget class and instance datatypes */
typedef struct _AwlClassRec*		AwlWidgetClass;
typedef struct _AwlRec*			AwlWidget;

/* Types for the type field of AwlExtern */
#define _TYPE_START	1
#define TYPE_CHAR	(_TYPE_START + 1)
#define TYPE_INT	(_TYPE_START + 2)
#define TYPE_FLOAT	(_TYPE_START + 3)
#define TYPE_STRING	(_TYPE_START + 4)
#define TYPE_LIST	(_TYPE_START + 5)
#define TYPE_ANY	(_TYPE_START + 6)
#define TYPE_FUNCTION	(_TYPE_START + 7)
#define TYPE_C_FUNCTION	(_TYPE_START + 8)
#define TYPE_A_FUNCTION	(_TYPE_START + 9)
#define TYPE_WCLASS	(_TYPE_START + 10)

typedef struct _awlextern {
     String name;
     int type;
     caddr_t ptr;
     caddr_t client_data;
} AwlExtern, *AwlExternList;

typedef void (*AwlExtProc)();

/* declare the class constant */
extern WidgetClass awlWidgetClass;

/* contact routines */
extern caddr_t awl_call();
extern void awl_break_set(), awl_break_delete(),
     awl_break_enable(), awl_break_disable();
#endif /* _Awl_h */
