#ifndef lint
static char *rcsid = "$Header: /usr/src/local/awl/RCS/builtins.c,v 2.1 90/04/19 20:04:39 jkh Exp $";
#endif

/*
 *
 *                     Copyright 1989
 *                    Jordan K. Hubbard
 *
 *		  PCS Computer Systeme, GmbH.
 *	             Munich, West Germany
 *
 *
 * This file is part of AWL.
 *
 * AWL is free software; you can redistribute it and/or modify
 * it under the terms of the GNU General Public License as published by
 * the Free Software Foundation; either version 1, or (at your option)
 * any later version.
 *
 * AWL is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 *
 * You should have received a copy of the GNU General Public License
 * along with AWL; see the file COPYING.  If not, write to
 * the Free Software Foundation, 675 Mass Ave, Cambridge, MA 02139, USA.
 *
 *
 */

/*
 * This file includes and "declares" all awl builtin functions. If you want
 * to add new functions to awl, first decide which <xxx>rtns.c file it
 * goes in (or create a new one) and DEFUN it there. Next, add an F_DECLARE
 * line for it to the add_builtins() function below. I wish I could figure
 * out a nice way to have DEFUN'd functions automatically declared, but I
 * haven't yet. I know how gdb does it and I don't particularly care for
 * that approach (grubbing through the object's symbol table! Ack!).
 *
 * $Log:	builtins.c,v $
 * Revision 2.1  90/04/19  20:04:39  jkh
 * Alpha checkin.
 * 
 * Revision 2.0  90/03/26  01:42:59  jkh
 * pre-beta check-in
 *
 */

#include "AwlP.h"
#include "y.tab.h"

/*
 * Declare any DEFUN'd builtins here. Syntax is: F_DECLARE(name, num_args);
 * If function takes a variable number of arguments, set num_args to -1.
 */
Export void add_builtins(aw)
AwlWidget aw;
{
     Address addr;

     /* awl specific functions */
     F_DECLARE(aw, _argc, 0);
     F_DECLARE(aw, _argv, 1);
     F_DECLARE(aw, assign, 2);
     F_DECLARE(aw, classid, 1);
     F_DECLARE(aw, classof, 1);
     F_DECLARE(aw, get, 1);
     F_DECLARE(aw, input, 2);
     F_DECLARE(aw, length, 1);
     F_DECLARE(aw, load, 1);
     F_DECLARE(aw, print, -1);
     F_DECLARE(aw, println, -1);
     F_DECLARE(aw, printname, 1);
     F_DECLARE(aw, symbol, 1);
     F_DECLARE(aw, typeid, 1);
     F_DECLARE(aw, typeof, 1);

     /* system functions */
     F_DECLARE(aw, chdir, 1);
     F_DECLARE(aw, chmod, 2);
     F_DECLARE(aw, chown, 3);
     F_DECLARE(aw, chroot, 1);
     F_DECLARE(aw, close, 1);
     F_DECLARE(aw, exec, 2);
     F_DECLARE(aw, exit, 1);
     F_DECLARE(aw, fork, 0);
     F_DECLARE(aw, free, 1);
     F_DECLARE(aw, fmt_time, 2);
     F_DECLARE(aw, getenv, 1);
     F_DECLARE(aw, getegid, 0);
     F_DECLARE(aw, geteuid, 0);
     F_DECLARE(aw, getgid, 0);
     F_DECLARE(aw, getpid, 0);
     F_DECLARE(aw, getuid, 0);
     F_DECLARE(aw, getwd, 0);
     F_DECLARE(aw, group, 1);
     F_DECLARE(aw, kill, 2);
     F_DECLARE(aw, malloc, 1);
     F_DECLARE(aw, open, 2);
     F_DECLARE(aw, perror, 1);
     F_DECLARE(aw, printf, -1);
     F_DECLARE(aw, read, 2);
     F_DECLARE(aw, readdir, 1);
     F_DECLARE(aw, setbuf, 2);
     F_DECLARE(aw, setgid, 1);
     F_DECLARE(aw, setuid, 1);
     F_DECLARE(aw, signal, 2);
     F_DECLARE(aw, sleep, 1);
     F_DECLARE(aw, sprintf, -1);
     F_DECLARE(aw, stat, 1);
     F_DECLARE(aw, system, 1);
     F_DECLARE(aw, time, 0);
     F_DECLARE(aw, user, 1);
     F_DECLARE(aw, write, 2);

     /* math ops */
     F_DECLARE(aw, acos, 1);
     F_DECLARE(aw, asin, 1);
     F_DECLARE(aw, atan, 1);
     F_DECLARE(aw, atan2, 2);
     F_DECLARE(aw, cos, 1);
     F_DECLARE(aw, exp, 1);
     F_DECLARE(aw, hypot, 2);
     F_DECLARE(aw, log, 1);
     F_DECLARE(aw, log10, 1);
     F_DECLARE(aw, pow, 2);
     F_DECLARE(aw, rand, 0);
     F_DECLARE(aw, sin, 1);
     F_DECLARE(aw, sqrt, 1);
     F_DECLARE(aw, srand, 1);
     F_DECLARE(aw, tan, 1);

     /* string ops */
     F_DECLARE(aw, strsed, -1);
     F_DECLARE(aw, substr, 1);

     /* toolkit ops */
     F_DECLARE(aw, XBell, 1);

     F_DECLARE(aw, XgInstallColorTable, 1);
     F_DECLARE(aw, XgListSelectItem, 2);
     F_DECLARE(aw, XgListUnselectItem, 2);
     F_DECLARE(aw, XgListChange, 2);

/*   F_DECLARE(aw, XtAddCallback, 3); */
     F_DECLARE(aw, XtAddTimeOut, 2);
     F_DECLARE(aw, XtAddWorkProc, 2);
     F_DECLARE(aw, XtAugmentTranslations, 2);
     F_DECLARE(aw, XtClass, 1);
     F_DECLARE(aw, XtCreate, -1);
     F_DECLARE(aw, XtCreateManaged, -1);
     F_DECLARE(aw, XtDestroy, 1);
     F_DECLARE(aw, XtGetSelectionTimeout, 0);
     F_DECLARE(aw, XtIsManaged, 1);
     F_DECLARE(aw, XtIsRealized, 1);
     F_DECLARE(aw, XtIsSensitive, 1);
     F_DECLARE(aw, XtIsSubclass, 2);
     F_DECLARE(aw, XtManage, 1);
     F_DECLARE(aw, XtMap, 1);
     F_DECLARE(aw, XtMove, 3);
     F_DECLARE(aw, XtName, 1);
     F_DECLARE(aw, XtNameToWidget, 2);
     F_DECLARE(aw, XtOverrideTranslations, 2);
     F_DECLARE(aw, XtParent, 1);
     F_DECLARE(aw, XtPopdown, 1);
     F_DECLARE(aw, XtPopup, 2);
     F_DECLARE(aw, XtRealize, 1);
     F_DECLARE(aw, XtRemoveTimeOut, 1);
     F_DECLARE(aw, XtRemoveWorkProc, 1);
     F_DECLARE(aw, XtResize, 4);
     F_DECLARE(aw, XtSetMappedWhenManaged, 2);
     F_DECLARE(aw, XtSetSelectionTimeout, 1);
     F_DECLARE(aw, XtSetSensitive, 2);
     F_DECLARE(aw, XtSuperclass, 1);
     F_DECLARE(aw, XtUninstallTranslations, 1);
     F_DECLARE(aw, XtUnmanage, 1);
     F_DECLARE(aw, XtUnmap, 1);
}

/*
 * Declare any builtin constants and variables.
 * Syntax is: C_DECLARE(aw, name, type, value).
 * If the type 0 is passed, it signifies that the name and string
 * value are the same (symbol becomes a string constant).
 * If you want to declare a variable (something that can be modified by
 * the user), use V_DECLARE(aw, name, type, address-of-value).
 * Try to follow the convention that all constants and variables are in
 * upper case and that all variables are preceeded by a dollar sign ($).
 * This will avoid confusion.
 */
Export void add_predefined_symbols(aw)
AwlWidget aw;
{
     Datum t;

#ifndef MAXINT
/* Make an informed guess */
#define MAXINT (~(1 << (8 * sizeof(int)) - 1))
#endif

     /* useful integer constants */
     C_DECLARE(aw, TRUE, INT, TrueDatum);
     C_DECLARE(aw, FALSE, INT, FalseDatum);
     datum_int(t) = EOF;		C_DECLARE(aw, EOF, INT, t);
     datum_int(t) = MAXINT;		C_DECLARE(aw, MAXINT, INT, t);
     datum_int(t) = 0;			C_DECLARE(aw, NULL, INT, t);
     datum_int(t) = MY_SIG_DFL;		C_DECLARE(aw, SIG_DFL, INT, t);
     datum_int(t) = MY_SIG_IGN;		C_DECLARE(aw, SIG_IGN, INT, t);

     /* user setable parameters */
     V_DECLARE(aw, $RADIX, IADDR, &awl_radix(aw));
     V_DECLARE(aw, $SEP, SADDR, &awl_sep(aw));

     /* useful float constants from <math.h> */
     datum_float(t) = M_E;		C_DECLARE(aw, M_E, FLOAT, t);
     datum_float(t) = M_LOG2E;		C_DECLARE(aw, M_LOG2E, FLOAT, t);
     datum_float(t) = M_LOG10E;		C_DECLARE(aw, M_LOG10E, FLOAT, t);
     datum_float(t) = M_LN2;		C_DECLARE(aw, M_LN2, FLOAT, t);
     datum_float(t) = M_LN10;		C_DECLARE(aw, M_LN10, FLOAT, t);
     datum_float(t) = M_PI;		C_DECLARE(aw, M_PI, FLOAT, t);
     datum_float(t) = M_PI_2;		C_DECLARE(aw, M_PI_2, FLOAT, t);
     datum_float(t) = M_PI_4;		C_DECLARE(aw, M_PI_4, FLOAT, t);
     datum_float(t) = M_1_PI;		C_DECLARE(aw, M_1_PI, FLOAT, t);
     datum_float(t) = M_2_PI;		C_DECLARE(aw, M_2_PI, FLOAT, t);
     datum_float(t) = M_2_SQRTPI;	C_DECLARE(aw, M_2_SQRTPI, FLOAT, t);
     datum_float(t) = M_SQRT2;		C_DECLARE(aw, M_SQRT2 1, FLOAT, t);
     datum_float(t) = M_SQRT1_2;	C_DECLARE(aw, M_SQRT1_2, FLOAT, t);
     datum_float(t) = MAXFLOAT;		C_DECLARE(aw, MAXFLOAT, FLOAT, t);

     /* misc interesting constants */
     datum_widget(t) = (Widget)aw;	C_DECLARE(aw, SELF, WIDGET, t);
     datum_file(t) = stdin;		C_DECLARE(aw, STDIN, FILEDESC, t);
     datum_file(t) = stdout;		C_DECLARE(aw, STDOUT, FILEDESC, t);
     datum_file(t) = stderr;		C_DECLARE(aw, STDERR, FILEDESC, t);
}
