#!/usr/local/bin/perl
#
# $Header: /usr/src/local/awl/RCS/extract.perl,v 2.1 90/04/19 20:05:09 jkh Exp $
#
# This perl script is used to extract all important CPP macros from a set of
# Toolkit or widget header files. It also converts enums to macro definitions
# so that they can be used as ordinary numeric constants.
#
# Perl (Practical Extraction and Report Language) is Copyright (c) 1989 by
# Larry Wall and may be obtained from him or your favorite local PD source
# archive.
#
# Thanks go to Michael Elbel of PCS Computer Systeme, GmbH for writing the
# initial version of this script.
#
# $Log:	extract.perl,v $
# Revision 2.1  90/04/19  20:05:09  jkh
# Alpha checkin.
# 
# Revision 2.0  90/03/26  01:44:23  jkh
# pre-beta check-in
# 
# Revision 1.2  90/03/11  05:34:39  jkh
# Changed format of outer loop to allow whole directories to be specified
# rather than individual files. This makes the Imakefile rules easier to
# specify (imake doesn't deal well with rules containing wildcards). Changed
# some comments around, re-indented, added RCS log and comment initiator.
# 
#
$pattern = @ARGV[0];
shift;
$dir = @ARGV[0];
shift;
open(list, "ls -1 $dir/*.h|");
print STDERR "Directory is ", $dir, ":\n";
while (<list>) {
     print STDERR "\tSearching ", $_;
     open(ARGV, $_);
     while (<>) {
	  ;# first choice gets textual defines
	  if (/^\s*#define\s+($pattern[A-Z]\w*)\s+(\"\w*\")/) {
	       print "#define $1 $2\n";
	       
	  ;# second choice gets numeric defines
	  } elsif (/^\s*#define\s+(X\w*)\s+([0-9]+)/) {
	       print "#define $1 $2\n";

	  ;# third choice splits up enums
          } elsif (/^\s*typedef\s+enum/) {
	       $_ = "$'";		# look only at the rest of the line
	       if (!(/\}/)) {	# if the enum is not on one line
		    $/ = "\}";	# change line delimiter to {
		    $_ .= <>;	# get the whole enum on one line
		    $/ = "\n";	# restore delimiter
		    $_ .= <>;	# get rest of line that ends enum
		    s/\n/ /g;	# kill newlines
	       }
	       s/\/\*.*\*\///;	# get rid of comments
	       /\}/;
	       $_ = "$`";	# throw away everything after }
	       # check for initialization of the enum
	       if(/\{\s*(\w+)\s*=\s*([0-9]+)/) {
		   $counter = $2;	# initialize counter
		   # print first item
		   printf ("#define $1 $counter\n");
		   $_ = "$'";
		   $counter++;
	       } else {
		   $counter = 0;	# initialize counter
		   /\{\s*/;
		   $_ = "$'";
	       }
	       while (/\w+/) {		#print all the items
		   printf ("#define $& $counter\n");
		   $counter++;
		   $_ = "$'";
	       }
	  }
     }
}
