#ifndef lint
static char *rcsid = "$Header: /usr/src/local/awl/RCS/strrtns.c,v 2.1 90/04/19 20:05:49 jkh Exp $";
#endif

/*
 *
 *                     Copyright 1989
 *                    Jordan K. Hubbard
 *
 *		  PCS Computer Systeme, GmbH.
 *	             Munich, West Germany
 *
 *
 * This file is part of AWL.
 *
 * AWL is free software; you can redistribute it and/or modify
 * it under the terms of the GNU General Public License as published by
 * the Free Software Foundation; either version 1, or (at your option)
 * any later version.
 *
 * AWL is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 *
 * You should have received a copy of the GNU General Public License
 * along with AWL; see the file COPYING.  If not, write to
 * the Free Software Foundation, 675 Mass Ave, Cambridge, MA 02139, USA.
 *
 *
 */

/*
 * This file contains all string manipulation built-ins.
 *
 * $Log:	strrtns.c,v $
 * Revision 2.1  90/04/19  20:05:49  jkh
 * Alpha checkin.
 * 
 * Revision 2.0  90/03/26  01:44:40  jkh
 * pre-beta check-in
 * 
 */

#include "AwlP.h"
#include "y.tab.h"

Local Value arg, arg2, arg3;

/*
 * strsed(STRING1, STRING2 [, start, end ]):
 * Do a strsed() on STRING1 with pattern STRING2, optionally returning
 * starting and ending positions.
 * I know that this looks a little grotty with everything about to fall
 * off the right, but that's the price I have to pay to prevent cascading
 * errors.
 *
 */
DEFUN(strsed)
{
     int range[2], nargs = awl_nparms(aw);
     String cp = NULL;
     Value arg4;

     if (nargs == 2 || nargs == 4) {
	  arg = get_arg(aw, 1, STRING, TRUE);
	  if (value_type(arg)) {
	       arg2 = get_arg(aw, 2, STRING, TRUE);
	       if (value_type(arg2)) {
		    if (nargs == 4) {
			 arg3 = get_arg(aw, 3, IADDR, TRUE);
			 if (value_type(arg3)) {
			      arg4 = get_arg(aw, 4, IADDR, TRUE);
			      if (value_type(arg4)) {
				   cp = strsed(value_string(arg),
					       value_string(arg2),
					       range);
				   if (cp) {
					*((int *)value_any(arg3)) = range[0];
					*((int *)value_any(arg4)) = range[1];
				   }
			      }
			 }
		    }
		    else {
			 cp = strsed(value_string(arg), value_string(arg2), 0);
		    }
	       }
	  }
     }
     else
	  exec_warn("strsed: Expected either 2 or 4 args, got %d", nargs);
     value_set(arg, DATA, STRING, aobj, new_aobj(cp));
     return(arg);
}

/*
 * substr(STRING, start, len):
 * Returns a "len" character long substring from STRING beginning at "start".
 */
DEFUN(substr)
{
     String tmp = NULL;

     arg  = get_arg(aw, 1, STRING, TRUE);	/* str */
     arg2 = get_arg(aw, 2, INT, FALSE);		/* start */
     arg3 = get_arg(aw, 3, INT, FALSE);		/* len */
     if (value_type(arg)) {
	  int len = strlen(value_string(arg));

	  if (value_int(arg2) + value_int(arg3) > len)
	       value_int(arg3) = len - value_int(arg2);
	  if (value_int(arg2) < len) {
	       tmp = XtMalloc(value_int(arg3) + 1);
	       strncpy(tmp, value_string(arg) + value_int(arg2),
		       value_int(arg3));
	       tmp[value_int(arg3)] = '\0';
	  }
     }
     value_set(arg, DATA, STRING, aobj, new_aobj(tmp));
     return(arg);
}
